Bug 186521 - devel/swig20 generated wrappers incompatibility with clang
Summary: devel/swig20 generated wrappers incompatibility with clang
Status: Closed FIXED
Alias: None
Product: Ports & Packages
Classification: Unclassified
Component: Individual Port(s) (show other bugs)
Version: Latest
Hardware: Any Any
: Normal Affects Only Me
Assignee: freebsd-ports-bugs (Nobody)
URL:
Keywords:
Depends on:
Blocks:
 
Reported: 2014-02-06 21:00 UTC by Diane Bruce
Modified: 2014-02-27 14:40 UTC (History)
0 users

See Also:


Attachments

Note You need to log in before you can comment on or make changes to this bug.
Description Diane Bruce 2014-02-06 21:00:00 UTC
discovered in building gnuradio 3.7.2

...
[ 48%] Building CXX object gr-vocoder/lib/CMakeFiles/gnuradio-vocoder.dir/g721_d
ecode_bs_impl.cc.o
/home/db/ports/gnuradio/work/.build/gr-fec/swig/fec_swigPYTHON_wrap.cxx:3267:51:
 error: implicit instantiation of undefined template 'std::__1::basic_string<cha
r, std::__1::char_traits<char>, std::__1::allocator<char> >'
    static swig_type_info *type_query(std::string name) {
                                                  
/usr/include/c++/v1/iosfwd:188:33: note: template is declared here
    class _LIBCPP_TYPE_VIS_ONLY basic_string;
                                ^
...

Old style #include <string.h> would work with c++ std:: but is deprecated

This bug should affect OSX as well and although I spotted several
similar bugs on SF bug tracker I did not spot this exact one.
It may still be a probem worth reporting upstream.

I am not sure if this will require a [exp-run].

	

swig template fails to include c++ <string>

Fix: 

Property changes on: swig20/files/patch-Lib_swigrun.swg
___________________________________________________________________
Added: svn:mime-type
## -0,0 +1 ##
+text/plain
\ No newline at end of property
Added: fbsd:nokeywords
## -0,0 +1 ##
+yes
\ No newline at end of property
Added: svn:eol-style
## -0,0 +1 ##
+native
\ No newline at end of property--9jg1hhOspMCQFlX8sHjMmgniVix9njIn0OAYP2ZMumyXXWoa
Content-Type: text/plain; name="file.diff"
Content-Transfer-Encoding: 7bit
Content-Disposition: attachment; filename="file.diff"

Index: swig20/files/patch-Lib_swigrun.swg
===================================================================
--- swig20/files/patch-Lib_swigrun.swg	(revision 0)
+++ swig20/files/patch-Lib_swigrun.swg	(working copy)
@@ -0,0 +1,10 @@
+--- Lib/swigrun.swg.orig	2013-09-15 09:11:43.000000000 -0500
++++ Lib/swigrun.swg	2014-02-06 14:04:08.000000000 -0500
+@@ -176,6 +176,7 @@
+ #include <string.h>
+ 
+ #ifdef __cplusplus
++#include <string>
+ extern "C" {
+ #endif
+ 
How-To-Repeat: Build  gnuradio 3.7.2
Comment 1 Edwin Groothuis freebsd_committer 2014-02-07 05:58:38 UTC
State Changed
From-To: open->feedback

Awaiting maintainers feedback (via the GNATS Auto Assign Tool)
Comment 2 Edwin Groothuis freebsd_committer 2014-02-07 05:58:38 UTC
Maintainer of devel/swig20,

Please note that PR ports/186521 has just been submitted.

If it contains a patch for an upgrade, an enhancement or a bug fix
you agree on, reply to this email stating that you approve the patch
and a committer will take care of it.

The full text of the PR can be found at:
    http://www.freebsd.org/cgi/query-pr.cgi?pr=ports/186521

-- 
Edwin Groothuis via the GNATS Auto Assign Tool
edwin@FreeBSD.org
Comment 3 dfilter service freebsd_committer 2014-02-27 14:33:04 UTC
Author: db
Date: Thu Feb 27 14:32:57 2014
New Revision: 346349
URL: http://svnweb.freebsd.org/changeset/ports/346349
QAT: https://qat.redports.org/buildarchive/r346349/

Log:
  - swig generated header uses #include <string.h> which is insufficient for clang
  
  PR:		ports/186521
  Approved by:	maintainer (timeout > 14 days)

Added:
  head/devel/swig20/files/patch-Lib_swigrun.swg   (contents, props changed)
Modified:
  head/devel/swig20/Makefile

Modified: head/devel/swig20/Makefile
==============================================================================
--- head/devel/swig20/Makefile	Thu Feb 27 14:31:33 2014	(r346348)
+++ head/devel/swig20/Makefile	Thu Feb 27 14:32:57 2014	(r346349)
@@ -3,6 +3,7 @@
 
 PORTNAME=	swig
 PORTVERSION=	2.0.11
+PORTREVISION=	1
 CATEGORIES=	devel
 MASTER_SITES=	SF/${PORTNAME}/${PORTNAME}/${PORTNAME}-${PORTVERSION}
 

Added: head/devel/swig20/files/patch-Lib_swigrun.swg
==============================================================================
--- /dev/null	00:00:00 1970	(empty, because file is newly added)
+++ head/devel/swig20/files/patch-Lib_swigrun.swg	Thu Feb 27 14:32:57 2014	(r346349)
@@ -0,0 +1,10 @@
+--- Lib/swigrun.swg.orig	2013-09-15 09:11:43.000000000 -0500
++++ Lib/swigrun.swg	2014-02-06 14:04:08.000000000 -0500
+@@ -176,6 +176,7 @@
+ #include <string.h>
+ 
+ #ifdef __cplusplus
++#include <string>
+ extern "C" {
+ #endif
+ 
_______________________________________________
svn-ports-all@freebsd.org mailing list
http://lists.freebsd.org/mailman/listinfo/svn-ports-all
To unsubscribe, send any mail to "svn-ports-all-unsubscribe@freebsd.org"
Comment 4 Diane Bruce freebsd_committer 2014-02-27 14:33:28 UTC
State Changed
From-To: feedback->closed

Committed fix for clang